/**
 * 
 * PAUL HUSSMAN
 * 260224172
 * COMP 409 ASSIGNMENT 2 QUESTION 1
 * 
 * 		Note: this code goes with the CV class
 * 
 */
import java.util.ArrayList;


//q1 - signal and urgent wait monitor semantics

class Monitor {
	
	boolean isLocked;

	// threads waiting to enter the monitor
	public static ArrayList<Thread> entranceQueue = new ArrayList<Thread>();

	// threads that have signaled
	public static ArrayList<Thread> signaledQueue = new ArrayList<Thread>();
	
	public static CV myCV = new CV();	// the condition variable
	
	void monitorEnter(){	// routine for entering a monitor
		if(isLocked){
			entranceQueue.add(Thread.currentThread());
			wait();
		} else {
			m.lock();
		}
	}
	
	void monitorExit(){		// routine for exiting a monitor
		schedule();
	}
	
	// schedules which threads to run such that it behaves as signal and urgent wait.
	public static void schedule(){
		if (!signaledQueue.isEmpty()){
			signaledQueue.remove(signaledQueue.size()-1);	// resume this thread
			myCV.notify();
		} else if (!entranceQueue.isEmpty()){
			entranceQueue.remove(entranceQueue.size()-1);	// resume this thread
			myCV.notify();
		}  else {
			m.unlock();
		}
	}
	
	
	

	
}