/**
 * 
 * PAUL HUSSMAN
 * 260224172
 * COMP 409 ASSIGNMENT 2 QUESTION 3
 * 
 * 
 */

public class Torus {

	private static final int SIZE_X = 30;			// x dimension
	private static final int SIZE_Y = 30;			// y dimension
	private static final int M = 10;				// number of objects in the torus
	private static final int SPEED = 1;			// speed of all objects
	private static final int TOTAL_TIME = 20000;	// time for simulation to run
	public static Point[] pointList = new Point[M];// collection of our points
	public static Thread[] threadList = new Thread[M];// collection of our threads
	
	
	public static void main(String[] args){
		
		int averageMoves = 0;
		
		// load up an array of the M points and start each one
		for (int i = 0; i < M; i++){
			pointList[i] = new Point(TOTAL_TIME, SIZE_X, SIZE_Y, SPEED);
		}
		// load up array of threads for each point and start each
		for (int i = 0; i < M; i++){
			threadList[i] = new Thread(pointList[i]); 
			threadList[i].start();
		}
		for (int i = 0; i < M; i++){
			try {threadList[i].join();} catch (InterruptedException ie) {}
		}
		for (int i = 0; i < pointList.length; i++){
			averageMoves += pointList[i].getMoveCount();
		}
		averageMoves = averageMoves/M;
		
		System.out.println(averageMoves);
		
	}
}